"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactCookie = require("react-cookie");

var _PropTypes = require("../constants/PropTypes");

var _LocaleProvider = _interopRequireDefault(require("../components/LocaleProvider"));

var __jsx = _react["default"].createElement;

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var BaseProvider = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(BaseProvider, _React$Component);

  var _super = _createSuper(BaseProvider);

  function BaseProvider() {
    (0, _classCallCheck2["default"])(this, BaseProvider);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(BaseProvider, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          cookies = _this$props.cookies,
          defaultLocale = _this$props.defaultLocale,
          siteLocales = _this$props.siteLocales,
          locale = _this$props.locale,
          children = _this$props.children;
      return __jsx(_reactCookie.CookiesProvider, {
        cookies: cookies
      }, __jsx(_LocaleProvider["default"], {
        defaultLocale: defaultLocale,
        siteLocales: siteLocales,
        locale: locale
      }, _react["default"].Children.only(children)));
    }
  }]);
  return BaseProvider;
}(_react["default"].Component);

(0, _defineProperty2["default"])(BaseProvider, "propTypes", {
  cookies: _propTypes["default"].instanceOf(_reactCookie.Cookies).isRequired,
  defaultLocale: _propTypes["default"].string,
  siteLocales: _propTypes["default"].arrayOf(_propTypes["default"].string.isRequired),
  locale: _PropTypes.localeShape,
  children: _propTypes["default"].element.isRequired
});
var _default = BaseProvider;
exports["default"] = _default;