"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _redux = require("redux");

var _reactRedux = require("react-redux");

var _reactCookie = require("react-cookie");

var _applyReducers = _interopRequireDefault(require("../redux/applyReducers"));

var _withLocaleComponent = _interopRequireDefault(require("../i18n/withLocaleComponent"));

var _default = function _default() {
  for (var _len = arguments.length, connectArgs = new Array(_len), _key = 0; _key < _len; _key++) {
    connectArgs[_key] = arguments[_key];
  }

  return function (Component, reducers) {
    return (0, _redux.compose)(_reactCookie.withCookies, _withLocaleComponent["default"], (0, _applyReducers["default"])(reducers), _reactRedux.connect.apply(void 0, connectArgs))(Component);
  };
};

exports["default"] = _default;