"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _reactCookie = require("react-cookie");

var _getDisplayName = _interopRequireDefault(require("../utils/getDisplayName"));

var _Statics = require("../constants/Statics");

var __jsx = _react["default"].createElement;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var _default = function _default(Page) {
  var WithCookies = /*#__PURE__*/function (_React$Component) {
    (0, _inherits2["default"])(WithCookies, _React$Component);

    var _super = _createSuper(WithCookies);

    (0, _createClass2["default"])(WithCookies, null, [{
      key: "getInitialProps",
      value: function () {
        var _getInitialProps = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(ctx) {
          var cookies, props;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  cookies = process.browser || typeof __NEXT_DATA__ !== "undefined" && __NEXT_DATA__.nextExport ? new _reactCookie.Cookies() : ctx.req && ctx.req.universalCookies;
                  _context.t0 = Page.getInitialProps;

                  if (!_context.t0) {
                    _context.next = 6;
                    break;
                  }

                  _context.next = 5;
                  return Page.getInitialProps(_objectSpread(_objectSpread({}, ctx), {}, {
                    cookies: cookies
                  }));

                case 5:
                  _context.t0 = _context.sent;

                case 6:
                  props = _context.t0;
                  return _context.abrupt("return", _objectSpread(_objectSpread({}, props), {}, {
                    cookies: cookies
                  }));

                case 8:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function getInitialProps(_x) {
          return _getInitialProps.apply(this, arguments);
        }

        return getInitialProps;
      }()
    }]);

    function WithCookies(props) {
      var _this;

      (0, _classCallCheck2["default"])(this, WithCookies);
      _this = _super.call(this, props);
      _this.cookies = process.browser ? new _reactCookie.Cookies() : props.cookies;
      return _this;
    }

    (0, _createClass2["default"])(WithCookies, [{
      key: "render",
      value: function render() {
        var props = (0, _extends2["default"])({}, this.props);
        delete props.cookies;
        return __jsx(Page, (0, _extends2["default"])({}, props, {
          cookies: this.cookies
        }));
      }
    }]);
    return WithCookies;
  }(_react["default"].Component);

  (0, _defineProperty2["default"])(WithCookies, "displayName", (0, _getDisplayName["default"])("withCookies", Page));
  (0, _defineProperty2["default"])(WithCookies, "propTypes", {
    cookies: _propTypes["default"].oneOfType([_propTypes["default"].shape({
      cookies: _propTypes["default"].objectOf(_propTypes["default"].string)
    }), _propTypes["default"].instanceOf(_reactCookie.Cookies)]).isRequired
  });
  return (0, _hoistNonReactStatics["default"])(WithCookies, Page, _Statics.NEXT_STATICS);
};

exports["default"] = _default;