"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _redux = require("redux");

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _BaseProvider = _interopRequireDefault(require("../components/BaseProvider"));

var _applyRedirect = _interopRequireDefault(require("../router/applyRedirect"));

var _withCookiesPage = _interopRequireDefault(require("../cookies/withCookiesPage"));

var _withLocalePage = _interopRequireDefault(require("../i18n/withLocalePage"));

var __jsx = _react["default"].createElement;

var _default = function _default(Page) {
  var BasePage = function BasePage(props) {
    return __jsx(_BaseProvider["default"], {
      cookies: props.cookies,
      locale: props.locale,
      defaultLocale: props.defaultLocale,
      siteLocales: props.siteLocales
    }, __jsx(Page, props));
  };

  return (0, _redux.compose)(_withLocalePage["default"], _applyRedirect["default"], _withCookiesPage["default"])((0, _hoistNonReactStatics["default"])(BasePage, Page));
};

exports["default"] = _default;