"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _reactApollo = require("react-apollo");

var _createBasePage = _interopRequireDefault(require("./createBasePage"));

var _createConfigureStore = _interopRequireDefault(require("../redux/createConfigureStore"));

var _withApolloClient = require("./withApolloClient");

var _withReduxStore = _interopRequireDefault(require("./withReduxStore"));

var _default = function _default(configureClient) {
  var configureStore = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : (0, _createConfigureStore["default"])();
  return function (reducers) {
    for (var _len = arguments.length, connectArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      connectArgs[_key - 1] = arguments[_key];
    }

    return (0, _reactApollo.compose)(_createBasePage["default"], (0, _withReduxStore["default"])(configureStore).apply(void 0, [reducers].concat(connectArgs)), (0, _withApolloClient.withApolloClientFactory)(function (Page) {
      return Page;
    }, function (ctx) {
      return {
        store: ctx.store
      };
    })(configureClient));
  };
};

exports["default"] = _default;