"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _redux = require("redux");

var _reactRedux = require("react-redux");

var _applyReducers = _interopRequireDefault(require("../redux/applyReducers"));

var _withStore = _interopRequireDefault(require("../redux/withStore"));

var __jsx = _react["default"].createElement;

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var _default = function _default(configureStore) {
  return function (reducers) {
    for (var _len = arguments.length, connectArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      connectArgs[_key - 1] = arguments[_key];
    }

    return function (Page) {
      var EnhancedPage = (0, _redux.compose)((0, _applyReducers["default"])(reducers), _reactRedux.connect.apply(void 0, connectArgs))(Page);

      var WithReduxStore = /*#__PURE__*/function (_React$Component) {
        (0, _inherits2["default"])(WithReduxStore, _React$Component);

        var _super = _createSuper(WithReduxStore);

        function WithReduxStore() {
          (0, _classCallCheck2["default"])(this, WithReduxStore);
          return _super.apply(this, arguments);
        }

        (0, _createClass2["default"])(WithReduxStore, [{
          key: "render",
          value: function render() {
            var _this$props = this.props,
                store = _this$props.store,
                props = (0, _objectWithoutProperties2["default"])(_this$props, ["store"]);
            return __jsx(_reactRedux.Provider, {
              store: store
            }, __jsx(EnhancedPage, props));
          }
        }]);
        return WithReduxStore;
      }(_react["default"].Component);

      (0, _defineProperty2["default"])(WithReduxStore, "propTypes", {
        store: _propTypes["default"].shape({
          subscribe: _propTypes["default"].func.isRequired,
          dispatch: _propTypes["default"].func.isRequired,
          getState: _propTypes["default"].func.isRequired
        }).isRequired
      });
      return (0, _withStore["default"])(configureStore)((0, _hoistNonReactStatics["default"])(WithReduxStore, EnhancedPage));
    };
  };
};

exports["default"] = _default;