"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _reduxThunk = _interopRequireDefault(require("redux-thunk"));

var _redux = require("redux");

var _logOnlyInProduction = require("redux-devtools-extension/logOnlyInProduction");

var _storeEnhancer = _interopRequireDefault(require("./storeEnhancer"));

var _middleware = _interopRequireDefault(require("./middleware"));

var _default = function _default(globalReducers) {
  return function (preloadedState, extraArgument) {
    return (0, _redux.createStore)(globalReducers ? (0, _redux.combineReducers)(globalReducers) : function () {
      return preloadedState || {};
    }, preloadedState, (0, _logOnlyInProduction.composeWithDevTools)((0, _redux.applyMiddleware)(_reduxThunk["default"].withExtraArgument(extraArgument), _middleware["default"]), (0, _storeEnhancer["default"])(globalReducers)));
  };
};

exports["default"] = _default;