"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _redux = require("redux");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _default = function _default(globalReducers) {
  return function (createStore) {
    return function (reducer, preloadedState, enhancer) {
      var store = createStore(reducer, preloadedState, enhancer);
      var _replaceReducer = store.replaceReducer;

      var soyaReducers = _objectSpread({}, globalReducers);

      return _objectSpread(_objectSpread({}, store), {}, {
        addReducer: function addReducer(nextReducers) {
          if (!nextReducers) {
            throw new Error("Missing nextReducers argument.");
          }

          var nextReducer = nextReducers;

          if (typeof nextReducers === "object") {
            var keys = Object.keys(nextReducers);
            keys.forEach(function (key) {
              if (soyaReducers[key] && soyaReducers[key] !== nextReducers[key]) {
                throw new Error("Duplicate reducer name: ".concat(key));
              }

              soyaReducers[key] = nextReducers[key];
            });
            nextReducer = (0, _redux.combineReducers)(soyaReducers);
          }

          _replaceReducer(nextReducer);
        },
        replaceReducer: function replaceReducer(nextReducers) {
          if (!nextReducers) {
            throw new Error("Missing nextReducers argument.");
          }

          var nextReducer = nextReducers;

          if (typeof nextReducers === "object") {
            soyaReducers = _objectSpread(_objectSpread({}, globalReducers), nextReducers);
            nextReducer = (0, _redux.combineReducers)(soyaReducers);
          }

          _replaceReducer(nextReducer);
        },
        soya: true
      });
    };
  };
};

exports["default"] = _default;