"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _getDisplayName = _interopRequireDefault(require("../utils/getDisplayName"));

var _Statics = require("../constants/Statics");

var __jsx = _react["default"].createElement;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var _default = function _default(configureClient) {
  return function (Page) {
    var configureClientIfNeeded = function configureClientIfNeeded(preloadedState, options) {
      if (!process.browser) {
        return configureClient(preloadedState, options);
      }

      if (!window.apolloClient) {
        window.apolloClient = configureClient(preloadedState, options);
      }

      return window.apolloClient;
    };

    var WithClient = /*#__PURE__*/function (_React$Component) {
      (0, _inherits2["default"])(WithClient, _React$Component);

      var _super = _createSuper(WithClient);

      (0, _createClass2["default"])(WithClient, null, [{
        key: "getInitialProps",
        value: function () {
          var _getInitialProps = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(ctx) {
            var apolloState, client, props;
            return _regenerator["default"].wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    apolloState = {};
                    client = configureClientIfNeeded(apolloState, {
                      cookies: ctx.cookies
                    });
                    _context.t0 = Page.getInitialProps;

                    if (!_context.t0) {
                      _context.next = 7;
                      break;
                    }

                    _context.next = 6;
                    return Page.getInitialProps(_objectSpread(_objectSpread({}, ctx), {}, {
                      client: client
                    }));

                  case 6:
                    _context.t0 = _context.sent;

                  case 7:
                    props = _context.t0;

                    if (!process.browser) {
                      // Extract query data from the Apollo's store
                      apolloState = client.cache.extract();
                    }

                    return _context.abrupt("return", _objectSpread(_objectSpread({}, props), {}, {
                      apolloState: apolloState
                    }));

                  case 10:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee);
          }));

          function getInitialProps(_x) {
            return _getInitialProps.apply(this, arguments);
          }

          return getInitialProps;
        }()
      }]);

      function WithClient(props) {
        var _this;

        (0, _classCallCheck2["default"])(this, WithClient);
        _this = _super.call(this, props);
        _this.client = configureClientIfNeeded(props.apolloState, {
          cookies: props.cookies
        });
        return _this;
      }

      (0, _createClass2["default"])(WithClient, [{
        key: "render",
        value: function render() {
          var props = (0, _extends2["default"])({}, this.props);
          delete props.apolloState;
          return __jsx(Page, (0, _extends2["default"])({}, this.props, {
            client: this.client
          }));
        }
      }]);
      return WithClient;
    }(_react["default"].Component);

    (0, _defineProperty2["default"])(WithClient, "displayName", (0, _getDisplayName["default"])("withClient", Page));
    (0, _defineProperty2["default"])(WithClient, "propTypes", {
      apolloState: _propTypes["default"].object.isRequired
    });
    return (0, _hoistNonReactStatics["default"])(WithClient, Page, _Statics.NEXT_STATICS);
  };
};

exports["default"] = _default;