"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.LocaleLink = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _link = _interopRequireDefault(require("next/link"));

var _redux = require("redux");

var _url = require("url");

var _router = require("next/router");

var _withLocaleComponent = _interopRequireDefault(require("../i18n/withLocaleComponent"));

var _PropTypes = require("../constants/PropTypes");

var _locale = require("../utils/locale");

var __jsx = _react["default"].createElement;

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var LocaleLink = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(LocaleLink, _React$Component);

  var _super = _createSuper(LocaleLink);

  function LocaleLink() {
    (0, _classCallCheck2["default"])(this, LocaleLink);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(LocaleLink, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          defaultLocale = _this$props.defaultLocale,
          locale = _this$props.locale,
          router = _this$props.router,
          props = (0, _objectWithoutProperties2["default"])(_this$props, ["children", "defaultLocale", "locale", "router"]);
      var as = props.as,
          href = props.href;
      delete props.siteLocales;
      var language = locale.language,
          country = locale.country;
      var localeSegment = (0, _locale.toPath)(locale, defaultLocale);
      href = href ? (0, _url.format)(href) : "";
      as = as ? (0, _url.format)(as) : "";
      var sep = href.indexOf("?") === -1 ? "?" : "&";
      return __jsx(_link["default"], (0, _extends2["default"])({}, props, {
        as: localeSegment + (0, _url.resolve)(router.pathname, as || href),
        href: "".concat((0, _url.resolve)(router.pathname, href)).concat(sep, "locale=").concat(language, "-").concat(country)
      }), children);
    }
  }]);
  return LocaleLink;
}(_react["default"].Component);

exports.LocaleLink = LocaleLink;
(0, _defineProperty2["default"])(LocaleLink, "propTypes", {
  children: _propTypes["default"].element.isRequired,
  defaultLocale: _propTypes["default"].string.isRequired,
  locale: _PropTypes.localeShape.isRequired,
  router: _propTypes["default"].object
});

var _default = (0, _redux.compose)(_withLocaleComponent["default"], _router.withRouter)(LocaleLink);

exports["default"] = _default;