"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _testUtils = _interopRequireDefault(require("react-dom/test-utils"));

var _reactCookie = require("react-cookie");

var _LocaleContext = _interopRequireDefault(require("../../i18n/LocaleContext"));

var _BaseProvider = _interopRequireDefault(require("../BaseProvider"));

var __jsx = _react["default"].createElement;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

describe("<BaseProvider />", function () {
  var rootContext;
  var ContextChecker = (0, _reactCookie.withCookies)(function (_ref) {
    var cookies = _ref.cookies;
    return __jsx(_LocaleContext["default"].Consumer, null, function (context) {
      return rootContext = _objectSpread(_objectSpread({}, context), {}, {
        cookies: cookies
      }), null;
    });
  });
  afterEach(function () {
    rootContext = undefined;
  });
  it("should add cookies, defaultLocale, locale, and siteLocales to child context", function () {
    _testUtils["default"].renderIntoDocument(__jsx(_BaseProvider["default"], {
      cookies: new _reactCookie.Cookies(),
      defaultLocale: "id-id",
      locale: {
        language: "en",
        country: "id"
      },
      siteLocales: ["id-id", "en-id"]
    }, __jsx(ContextChecker, null)));

    expect(rootContext).toMatchSnapshot();
  });
});