"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _getDisplayName = _interopRequireDefault(require("../utils/getDisplayName"));

var _PropTypes = require("../constants/PropTypes");

var _LocaleContext = _interopRequireDefault(require("./LocaleContext"));

var __jsx = _react["default"].createElement;

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var _default = function _default(Component) {
  var WithLocale = /*#__PURE__*/function (_React$Component) {
    (0, _inherits2["default"])(WithLocale, _React$Component);

    var _super = _createSuper(WithLocale);

    function WithLocale() {
      (0, _classCallCheck2["default"])(this, WithLocale);
      return _super.apply(this, arguments);
    }

    (0, _createClass2["default"])(WithLocale, [{
      key: "render",
      value: function render() {
        var _this = this;

        return __jsx(_LocaleContext["default"].Consumer, null, function (context) {
          var locale = _this.props.locale || context.locale;

          if (typeof locale === "string") {
            var _locale$split = locale.split("-"),
                _locale$split2 = (0, _slicedToArray2["default"])(_locale$split, 2),
                language = _locale$split2[0],
                country = _locale$split2[1];

            locale = {
              country: country,
              language: language
            };
          }

          return __jsx(Component, (0, _extends2["default"])({}, _this.props, context, {
            locale: locale
          }));
        });
      }
    }]);
    return WithLocale;
  }(_react["default"].Component);

  (0, _defineProperty2["default"])(WithLocale, "displayName", (0, _getDisplayName["default"])("withLocale", Component));
  (0, _defineProperty2["default"])(WithLocale, "propTypes", {
    locale: _propTypes["default"].oneOfType([_PropTypes.localeShape, _propTypes["default"].string])
  });
  return (0, _hoistNonReactStatics["default"])(WithLocale, Component);
};

exports["default"] = _default;