"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _getDisplayName = _interopRequireDefault(require("../utils/getDisplayName"));

var _PropTypes = require("../constants/PropTypes");

var _locale = require("../utils/locale");

var _Statics = require("../constants/Statics");

var __jsx = _react["default"].createElement;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var _default = function _default(Page) {
  var WithLocale = /*#__PURE__*/function (_React$Component) {
    (0, _inherits2["default"])(WithLocale, _React$Component);

    var _super = _createSuper(WithLocale);

    function WithLocale() {
      (0, _classCallCheck2["default"])(this, WithLocale);
      return _super.apply(this, arguments);
    }

    (0, _createClass2["default"])(WithLocale, [{
      key: "render",
      value: function render() {
        return __jsx(Page, this.props);
      }
    }], [{
      key: "getInitialProps",
      value: function () {
        var _getInitialProps = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(_ref) {
          var asPath, ctx, context, defaultLocale, siteLocales, _ctx$query$locale$spl, _ctx$query$locale$spl2, language, country, props;

          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  asPath = _ref.asPath, ctx = (0, _objectWithoutProperties2["default"])(_ref, ["asPath"]);
                  context = process.browser ? window.__NEXT_DATA__.props : ctx.req;
                  defaultLocale = context.defaultLocale, siteLocales = context.siteLocales;

                  if (process.browser) {
                    if (ctx.query.locale) {
                      _ctx$query$locale$spl = ctx.query.locale.split("-"), _ctx$query$locale$spl2 = (0, _slicedToArray2["default"])(_ctx$query$locale$spl, 2), language = _ctx$query$locale$spl2[0], country = _ctx$query$locale$spl2[1];

                      if (siteLocales.indexOf("".concat(language, "-").concat(country)) !== -1) {
                        context.locale = {
                          language: language,
                          country: country
                        };
                      }
                    }
                  }

                  _context.t0 = Page.getInitialProps;

                  if (!_context.t0) {
                    _context.next = 9;
                    break;
                  }

                  _context.next = 8;
                  return Page.getInitialProps(_objectSpread(_objectSpread({}, ctx), {}, {
                    asPath: (0, _locale.ensurePath)(asPath, context.locale, defaultLocale),
                    defaultLocale: defaultLocale,
                    siteLocales: siteLocales,
                    locale: context.locale
                  }));

                case 8:
                  _context.t0 = _context.sent;

                case 9:
                  props = _context.t0;
                  return _context.abrupt("return", _objectSpread(_objectSpread({}, props), {}, {
                    defaultLocale: defaultLocale,
                    siteLocales: siteLocales,
                    locale: context.locale
                  }));

                case 11:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function getInitialProps(_x) {
          return _getInitialProps.apply(this, arguments);
        }

        return getInitialProps;
      }()
    }]);
    return WithLocale;
  }(_react["default"].Component);

  (0, _defineProperty2["default"])(WithLocale, "displayName", (0, _getDisplayName["default"])("withLocale", Page));
  (0, _defineProperty2["default"])(WithLocale, "propTypes", {
    defaultLocale: _propTypes["default"].string,
    siteLocales: _propTypes["default"].arrayOf(_propTypes["default"].string.isRequired),
    locale: _PropTypes.localeShape
  });
  return (0, _hoistNonReactStatics["default"])(WithLocale, Page, _Statics.NEXT_STATICS);
};

exports["default"] = _default;