"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _default = function _default() {
  var queries = {};
  return function (next) {
    return function (_ref) {
      var soya = _ref.soya,
          action = (0, _objectWithoutProperties2["default"])(_ref, ["soya"]);

      if (typeof soya !== "undefined") {
        var load = soya.load,
            _soya$id = soya.id,
            id = _soya$id === void 0 ? action.type : _soya$id;

        if (typeof id !== "string") {
          throw new Error("Expected soya action id to be a string.");
        }

        if (typeof load !== "function") {
          throw new Error("Expected soya action load to be a function.");
        }

        var resolve = function resolve(soya) {
          // eslint-disable-next-line callback-return
          next(_objectSpread(_objectSpread({}, action), {}, {
            soya: soya
          }));
          delete queries[id];
          return soya;
        };

        var reject = resolve;

        if (!queries[id]) {
          queries[id] = load().then(resolve, reject);
        }

        return queries[id];
      }

      return next(action);
    };
  };
};

exports["default"] = _default;