"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _router = _interopRequireDefault(require("next/router"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _querystring = require("querystring");

var _pathToRegexp = _interopRequireDefault(require("path-to-regexp"));

var _getDisplayName = _interopRequireDefault(require("../utils/getDisplayName"));

var _decodeParam = _interopRequireDefault(require("../utils/decodeParam"));

var _ensureRedirect2 = _interopRequireDefault(require("../utils/ensureRedirect"));

var _parseRedirectionPath = _interopRequireDefault(require("../utils/parseRedirectionPath"));

var _locale = require("../utils/locale");

var _Statics = require("../constants/Statics");

var __jsx = _react["default"].createElement;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var _default = function _default(Page) {
  var _class, _temp;

  return (0, _hoistNonReactStatics["default"])((_temp = _class = /*#__PURE__*/function (_React$Component) {
    (0, _inherits2["default"])(_class, _React$Component);

    var _super = _createSuper(_class);

    function _class() {
      (0, _classCallCheck2["default"])(this, _class);
      return _super.apply(this, arguments);
    }

    (0, _createClass2["default"])(_class, [{
      key: "render",
      value: function render() {
        var props = _objectSpread({}, this.props);

        delete props.method;
        delete props.redirects;
        return __jsx(Page, props);
      }
    }], [{
      key: "getInitialProps",
      value: function () {
        var _getInitialProps = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(ctx) {
          var _ref, defaultLocale, locale, method, _ref$redirects, redirects, siteLocales, _i, _Object$keys, from, _ensureRedirect, redirectMethod, page, to, _ret, props;

          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _ref = process.browser ? window.__NEXT_DATA__.props : ctx.req, defaultLocale = _ref.defaultLocale, locale = _ref.locale, method = _ref.method, _ref$redirects = _ref.redirects, redirects = _ref$redirects === void 0 ? {} : _ref$redirects, siteLocales = _ref.siteLocales;

                  if (!process.browser) {
                    _context.next = 13;
                    break;
                  }

                  _i = 0, _Object$keys = Object.keys(redirects);

                case 3:
                  if (!(_i < _Object$keys.length)) {
                    _context.next = 13;
                    break;
                  }

                  from = _Object$keys[_i];
                  _ensureRedirect = (0, _ensureRedirect2["default"])(redirects[from]), redirectMethod = _ensureRedirect.method, page = _ensureRedirect.page, to = _ensureRedirect.to;

                  if (!(redirectMethod.toLowerCase() === method.toLowerCase())) {
                    _context.next = 10;
                    break;
                  }

                  _ret = function () {
                    var keys = [];
                    var regexp = (0, _pathToRegexp["default"])(from, keys);
                    var match = regexp.exec((0, _locale.trimPath)(ctx.asPath, defaultLocale, siteLocales));

                    if (match !== null) {
                      var localeSegment = (0, _locale.toPath)(locale, defaultLocale);
                      var params = keys.reduce(function (params, key, index) {
                        var param = match[index + 1]; // istanbul ignore else

                        if (param) {
                          params[key.name] = (0, _decodeParam["default"])(param);
                        }

                        return params;
                      }, {});
                      var redirectionPath = localeSegment + (0, _parseRedirectionPath["default"])(to, params);

                      _router["default"].push("".concat(page, "?").concat((0, _querystring.stringify)(ctx.query)), redirectionPath);

                      return {
                        v: {}
                      };
                    }
                  }();

                  if (!(typeof _ret === "object")) {
                    _context.next = 10;
                    break;
                  }

                  return _context.abrupt("return", _ret.v);

                case 10:
                  _i++;
                  _context.next = 3;
                  break;

                case 13:
                  _context.t0 = Page.getInitialProps;

                  if (!_context.t0) {
                    _context.next = 18;
                    break;
                  }

                  _context.next = 17;
                  return Page.getInitialProps(ctx);

                case 17:
                  _context.t0 = _context.sent;

                case 18:
                  props = _context.t0;
                  return _context.abrupt("return", _objectSpread(_objectSpread({}, props), {}, {
                    method: method,
                    redirects: redirects
                  }));

                case 20:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function getInitialProps(_x) {
          return _getInitialProps.apply(this, arguments);
        }

        return getInitialProps;
      }()
    }]);
    return _class;
  }(_react["default"].Component), (0, _defineProperty2["default"])(_class, "displayName", (0, _getDisplayName["default"])("applyRedirect", Page)), _temp), Page, _Statics.NEXT_STATICS);
};

exports["default"] = _default;