"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _decodeParam = _interopRequireDefault(require("../decodeParam"));

describe("DecodeParam Utils", function () {
  it("should return as is if it's not a string or is an empty string", function () {
    expect((0, _decodeParam["default"])("")).toBe("");
    expect((0, _decodeParam["default"])({
      a: 1
    })).toMatchSnapshot();
  });
  it("should throw an URIError exception when used wrongly", function () {
    expect(function () {
      (0, _decodeParam["default"])("/error/%A0");
    }).toThrowErrorMatchingSnapshot();
  });
});