"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _default = function _default(param) {
  if (typeof param !== "string" || param.length === 0) {
    return param;
  }

  try {
    return decodeURIComponent(param);
  } catch (err) {
    // istanbul ignore else
    if (err instanceof URIError) {
      err.message = "Failed to decode param \"".concat(param, "\"");
      err.status = err.statusCode = 400;
    }

    throw err;
  }
};

exports["default"] = _default;